Anypoint LDAP Connector Demo for Active Directory
=================================================


INTRODUCTION
------------
The connector demo consists of the following projects:

* ldap-activedirectory - Provides sample flow on how to add an entry and set its password in Active Directory.

HOW TO RUN DEMO
---------------

### Prerequisites
In order to build and run this project, you'll need;

* Anypoint Studio with Mule ESB 3.7.x EE Runtime.
* Anypoint LDAP Connector v2.1.0 or higher.
* Active Directory instance credentials.
* Active Directory to have certificate signed from a well known certification authority or otherwise the following be required in order to run locally. In order to execute on CloudHub please follow the steps on the section below.
* In case the certificate is not signed from a well known certification authority then the certificate to be used for Active Directory is needed
  a. Determine the location of JRE used in Anypoint Studio ( This can be done by Window > Preferences > Java > Installed JREs )
  b. Open a terminal and change directory to the location of JRE/lib/security 
  c. Issue the following command "keytool -import -alias <anyAliasForTheCertificateEntry> -file <certificateFile> -keystore cacerts -storepass <storePassword>. The default password for cacerts is "changeit"

### Test the flows

With Anypoint Studio up and running, open the Import wizard from the File menu. A pop-up wizard will offer you the chance to pick Anypoint Studio Project from External Location. On the next wizard window point Project Root to the location of the demo project and select the Server Runtime as Mule Server 3.7.0 EE. Once successfully imported the studio will automatically present the Anypoint Flows.

In the mule-app.properties change the authDn, authPassword and url for the Active Directory, also change the newUserCn, newUserDn, newUserPassword and newUserSamAccountName for the new user below.

* Run the demo project.
* In web browser visit http://localhost:8081 to add the user to Active Directory. You should get a response such as "Tested : found the entry that was made".

### Execution on CloudHub
In order to run on CloudHub extended configuration needs to be added to ldap:tls-config such as below
    <ldap:tls-config name="LDAP__TLS_Configuration" authDn="${authDn}" authPassword="${authPassword}" url="${url}" doc:name="LDAP: TLS Configuration">
        <ldap:extended-configuration>
            <ldap:extended-configuration key="org.mule.module.ldap.trustStorePath">${mule.home}/apps/${app.name}/classes/clienttruststore.jks</ldap:extended-configuration>
            <ldap:extended-configuration key="org.mule.module.ldap.trustStorePassword">${trustStorePassword}</ldap:extended-configuration>
        </ldap:extended-configuration>
    </ldap:tls-config>
Also the clienttruststore.jks file will need to be added to src/main/resources folder.

SUMMARY
-------

On completion of the demo you have been able to make an entry into Active Directory with the specified user name and password and then verified the same exists. Make sure to delete the same from Active Directory or provide a different value for the new user settings before executing the demo again.
